Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 154434 - kernel dm-multipath: Make SCSI sense data available in bio end_io path for dm-emc
Summary: kernel dm-multipath: Make SCSI sense data available in bio end_io path for dm...
Keywords:
Status: CLOSED WONTFIX
Alias: None
Product: Fedora
Classification: Fedora
Component: device-mapper-multipath
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Alasdair Kergon
QA Contact:
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2005-04-11 17:36 UTC by Alasdair Kergon
Modified: 2010-04-27 13:51 UTC (History)
9 users (show)

Fixed In Version:
Doc Type: Enhancement
Doc Text:
Clone Of:
Environment:
Last Closed: 2010-04-27 13:51:51 UTC


Attachments (Terms of Use)
Bio end_io patch (deleted)
2005-04-11 17:36 UTC, Alasdair Kergon
no flags Details | Diff
hardware-handler sense data patch (deleted)
2005-04-11 17:39 UTC, Alasdair Kergon
no flags Details | Diff
Make sense buffer available in SCSI request struct [already upstream] (deleted)
2005-04-20 09:01 UTC, Lars Marowsky-Bree
no flags Details | Diff
Updated bio-end_io-sense patch (deleted)
2005-04-20 09:04 UTC, Lars Marowsky-Bree
no flags Details | Diff

Description Alasdair Kergon 2005-04-11 17:36:15 UTC
The attached two patches enable SCSI sense data to be available in the
bio-end_io path and use it in dm-mpath's hwhandler as well as dm-emc.c.

This allows the EMC module to take different action according to what sort of
I/O failure has occurred.

[From Jens Axboe & Lars Marowsky-Bree, Suse]

Comment 1 Alasdair Kergon 2005-04-11 17:36:16 UTC
Created attachment 112959 [details]
Bio end_io patch

Comment 3 Alasdair Kergon 2005-04-11 17:39:16 UTC
Created attachment 112961 [details]
hardware-handler sense data patch

Comment 4 Lars Marowsky-Bree 2005-04-20 09:01:35 UTC
Created attachment 113395 [details]
Make sense buffer available in SCSI request struct [already upstream]

Pre-requisite to having the sense data available in the bio

Comment 5 Lars Marowsky-Bree 2005-04-20 09:04:17 UTC
Created attachment 113396 [details]
Updated bio-end_io-sense patch

This obsoletes the first patch, but I can't set that flag ;)

s->valid didn't imply what Jens thought, and the struct request_sense is
generally not the right one to use here. This corrects parsing the sense buffer
and setting it in the bio, also sets bi_error correctly if no sense data is
available (by setting it to the errno).

Comment 6 Lars Marowsky-Bree 2005-04-20 09:06:55 UTC
The hardware handler patch is still correct.

Comment 7 Alasdair Kergon 2005-04-21 17:41:31 UTC
2 patches added to 2.6.12-rc2-udm1

Comment 8 Alasdair Kergon 2010-04-27 13:51:51 UTC
Superceded by request-based multipath.


Note You need to log in before you can comment on or make changes to this bug.